﻿<%@ Page Language="VB" AutoEventWireup="true" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
  <link href="media/css/demo_table.css" rel="stylesheet" type="text/css" />
  <script src="media/js/jquery.js" type="text/javascript"></script>
  <script src="media/js/jquery.dataTables.js" type="text/javascript"></script>
  <script type="text/javascript" charset="utf-8">
    var oTable;

    // this query is set to pull back 1500 records even though Netflix sends only 500 at a time.
    var query = "http://odata.netflix.com/v1/Catalog/Titles?$orderby=Name&$top=1500"
    $(document).ready(function () { GetData() });

    function GetData() {

      var url = query
                    + "&$callback=displayResults"  
                    + "&$format=json"; 
      $.ajax({
        dataType: "jsonp",
        url: url
      });
    }

    function displayResults(results) {

      var entities;
      var redraw;
      if (results.d[0] == undefined) {
        queryNext = results.d.__next;
        entities = results.d.results;
      }
      else {
        queryNext = "";
        entities = results.d;
      }
      //instantiate dataTable if necessary
      if (oTable ==null)
        oTable = $('#Netflix').dataTable();

      for (var post in entities) {

        if (post == entities.length - 1) {
          redraw = true;
        }
        else
          redraw = false;
        
       //setting redraw to false ...don't redraw after EVERY row..overwhelms client
        oTable.fnAddData([
		    entities[post].Name, entities[post].Rating, entities[post].Runtime], redraw);

      }
      if (queryNext > "") {
        $('#loadingmessage').html("<b>Getting More Data... </b><img src='media/images/ajax-loader.gif'/>");
        query = FixNetFlixUrl(queryNext);
        GetData();
      }
      else
        $('#loadingmessage').html("Data Load Complete").delay(1200).fadeOut(1400);

  }

  //dealing with an oddity in the way netflix constructs continuation token
    //as of Nov 2010, this port 20000 is in every token. Pay attention in case Netflix changes that. 
    function FixNetFlixUrl(url) {
      if (url.indexOf("netflix.com:20000") > 0) {
        return url.replace("netflix.com:20000", "netflix.com");
      }
      else {
        return url;
      }
    } 
  </script>
</head>
  <body>
    <form id="form1" runat="server">
      <table id="Netflix" width="100%">
        <thead>
          <tr><th width="50%">Title</th>
              <th>Rating</th>
              <th>Runtime</th></tr>
        </thead>
        <tbody id="netflixBody"/>
      </table>
      <br /><div id="loadingmessage"><b>
        <br />
        Getting Data... </b><img src="media/images/ajax-loader.gif" /></div>
    </form>
  </body>
</html>
